package dynamic_data_structures;

public class ArrayQueue<T> implements Queue<T> {
	
	private int head;
	private int tail;
	private T[] queue;
	
	@SuppressWarnings("unchecked")
	public ArrayQueue( int size ) {
		head = tail = 0;
		queue = (T[]) new Object [ size ];
	}
	
	public ArrayQueue() { this( 10 ); }
	
	public T dequeue() throws EmptyQueueException {
		if( !empty() ) { 
			T elem = queue[head];
			if ( head == (queue.length-1) )
				head = 0;
			else
				head++;
			return elem;
		}
		else
			throw new EmptyQueueException("the dequeue operation was not posible!");	
	}
	
	public boolean empty() {
		return head == tail; 
	}
	
	public void enqueue(T elem) {
		if (full())
			resizeQueueTo(queue.length*2);
		queue[tail] = elem; 
		if( tail == (queue.length-1) ) 
			tail = 0; 
		else tail++; 
	}
	
	@SuppressWarnings("unchecked")
	public void resizeQueueTo(int max) {
		T[] tmpQueue = (T[]) new Object [ max ];
		
		if(tail < head)
			tail += queue.length-head;
		else
			tail -= head;
		
		for(int i = 0; i < tail; ++i) {
			tmpQueue[i] = queue[(i+head) % queue.length];
		}		
		head = 0;		
		queue = tmpQueue;
	}

	public boolean full() { 
		if ( (( tail == queue.length-1) && ( head == 0)) || ( head == ( tail+1)) ) {
			resizeQueueTo(2*queue.length);
		}
		return false;
	}
	
	public T head() throws EmptyQueueException {
		if( !empty() ) {
			return queue[head];
		}
		else
			throw new EmptyQueueException("The queue is empty"); 
	}

	public void print2() {
		if (!empty()){
			int pos = 0;
			for(int i = 0; i < queue.length; ++i) {
				pos = (i+head) % queue.length;
				if ( pos == tail )
					break;
				System.out.print(queue[pos]+ "|");
			}
			System.out.println();
		}else{
			System.out.println("EMPTY");
		}
	}
	
	public void print() {
		if (!empty()){
			int pos = 0;
			if (head<tail)
				for(pos=head; pos<tail; pos++)
					System.out.print(queue[pos]+ "|");
			else {
				for(pos=head; pos<queue.length; pos++)
					System.out.print(queue[pos]+ "|");
				for(pos=0; pos<tail; pos++)
					System.out.print(queue[pos]+ "|");
			}
	        System.out.println();
	    }else{
		    System.out.println("EMPTY");
	   }
	}

}// end of class ArrayQueue
